/*!
 * @license si18n.js - v1.4.4
 * Copyright (c) José dBruxelles <jd.bruxelles.dev/c>.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree or
 * at https://jdbruxelles.mit-license.org
 *
 * Make translation management easier and more efficient.
 */export default class Si18n{static version="1.4.4";#noop(){}#isInitialized=!1;#options={lang:"",fallbackLang:"",locales:{},availableLocales:[],path:null,activeClass:"",togglersSelector:"",isTogglerSelect:!1,saveLang:!0,saveAs:"lang",translate:this.#noop,reloadPage:!1,callback:this.#noop};constructor(a){"object"==typeof a&&setTimeout(()=>{this.init(a)},50)}init(a={}){if(this.#isInitialized)return;const b="https://si18n.js.bruxelles.dev/#options",c=Object.keys(a),d=c.includes("path"),e=()=>{throw new Error("The togglersSelector option must be a valid selector. Or you may forget to add the selected HTML element(s). See docs https://si18n.js.bruxelles.dev/#options")},f=a=>this.#options.availableLocales.includes(a);if(0===c.length)throw new Error(`No options provided. See docs ${"https://si18n.js.bruxelles.dev/#options"}`);else if(!d&&!c.includes("locales"))throw new Error(`Missing required options. See docs ${"https://si18n.js.bruxelles.dev/#options"}`);if(a.fallbackLang){if("string"!=typeof a.fallbackLang)throw new Error(`The fallbackLang option must be a string. See docs ${b}`);this.#options.fallbackLang=a.fallbackLang}else if(a.lang)this.#options.fallbackLang=a.lang;else throw new Error(`The lang option is required when no fallbackLang option is set. See docs ${"https://si18n.js.bruxelles.dev/#options"}`);if(a.locales){if(!d&&"object"!=typeof a.locales)throw new Error(`The locales option must be an object. See docs ${b}`);this.#options.locales=a.locales}this.#options.availableLocales=a.availableLocales||Object.keys(this.#options.locales),a.translate&&(this.#options.translate=a.translate),a.saveAs&&(this.#options.saveAs=a.saveAs),"function"==typeof a.onLocaleChanged&&(this.#options.callback=a.onLocaleChanged);const g=new URLSearchParams(window.location.search),h=g.get(this.#options.saveAs),i=localStorage.getItem(this.#options.saveAs);if(Si18n.#isUndefined(a.saveLang)||(this.#options.saveLang=a.saveLang),null!==h&&f(h))this.#options.lang=h;else if(this.#options.saveLang&&i&&f(i))this.#options.lang=i||a.lang;else if(a.lang)this.#options.lang=a.lang;else{const a=navigator.language.substring(0,2);this.#options.lang=f(a)?a:this.#options.fallbackLang}if(Si18n.#isUndefined(a.reloadPage)||(this.#options.reloadPage=a.reloadPage),d){if("string"!=typeof a.path)throw new Error(`The path option must be a string. See docs ${b}`);const c=Array.isArray(a.availableLocales);if(!c||c&&0===a.availableLocales.length)throw new Error(`The availableLocales option is required when using the path option. See docs ${b}`);this.#options.path=a.path,this.#options.lang!==this.#options.fallbackLang&&this.#loadLocale({lang:this.#options.fallbackLang}),this.#loadLocale({lang:this.#options.lang,cb:()=>{this.#translate(),this.#options.callback()}})}else this.#translate(),this.#options.callback();if(this.#isInitialized=!0,"string"==typeof a.togglersSelector)if(a.isTogglerSelect){const b=document.querySelector(a.togglersSelector);b||e();const c=`option[value="${this.#options.lang}"]`,d=b.querySelector(c);d.setAttribute("selected",!0),b.querySelectorAll("option").forEach(a=>{this.getLocales().includes(a.value)||a.setAttribute("disabled",!0)}),b.addEventListener("change",()=>{d.removeAttribute("selected")},{once:!0}),b.addEventListener("change",()=>{const a=b.querySelector("option:checked");this.getLocales().includes(a.value)&&this.setLocale(a.value)})}else{const b=document.querySelectorAll(a.togglersSelector),c="string"==typeof a.activeClass;if(b.length||e(),c)for(const c of b.values())c.dataset.lang===this.#options.lang&&c.classList.add(a.activeClass);b.forEach(d=>{f(d.dataset.lang)&&d.addEventListener("click",()=>{c&&(b.forEach(b=>{b.classList.remove(a.activeClass)}),d.classList.add(a.activeClass)),this.setLocale(d.dataset.lang)})})}}setLocale(a){const{saveLang:b,saveAs:c,reloadPage:d,callback:e}=this.#options;b&&localStorage.setItem(c,a),d&&window.location.reload(),this.#loadLocale({lang:a,cb:()=>{this.#options.lang=a,this.#translate(),e()}})}getLocale(){return this.#options.lang}getLocales(){return this.#options.availableLocales}#getFallbackObj(){return this.#options.locales[this.#options.fallbackLang]}static async getJSON(a,b){fetch(a).then(a=>a.json()).then(a=>{b&&b(a)}).catch(a=>{console.error(a)})}#loadLocale({lang:a,cb:b}){Object.keys(this.#options.locales).includes(a)?"function"==typeof b&&b(this.#options.locales[a]):Si18n.getJSON(`${this.#options.path}/${a}.json`,c=>{this.#options.locales[a]=c,"function"==typeof b&&b(c)})}#translate(){let a=!1;Si18n.#isUndefined(this.#options.locales[this.#options.lang]?.rtl)||(a=this.#options.locales[this.#options.lang].rtl),document.documentElement.dir=a?"rtl":"ltr",document.documentElement.lang=this.getLocale();const b=document.querySelectorAll("[data-si18n]"),c=b.length;if(0<c){const a={title:"si18nTitle",label:"si18nLabel",alt:"si18nAlt","aria-label":"si18nAriaLabel",value:"si18nValue",content:"si18nContent",placeholder:"si18nPlaceholder"};for(let d=0;d<c;d++){const c=b[d];if(!c.dataset.si18n)continue;const e=this.t(c.dataset.si18n);"false"!==c.dataset.si18nDefault&&("true"===c.dataset.si18nHtml?c.innerHTML=e:c.textContent=e),Object.keys(a).forEach(b=>{a[b]in c.dataset&&c.setAttribute(b,e)})}}this.#options.translate()}t(a,b){let c=!1,d=this.#options.locales[this.#options.lang];const e=a.split(".");try{for(let b=0;b<e.length;b++)if(d=d[e[b]],(Si18n.#isUndefined(d)||""===d)&&!c){d=this.#getFallbackObj(),c=!0;for(const a of e)d=d[a];(Si18n.#isUndefined(d)||""===d)&&this.#triggerErrorPathNotFound(a)}}catch(b){this.#triggerErrorPathNotFound(a)}if(b&&"object"==typeof b)for(const a in b)d=d.replace(new RegExp(`\\%{${a}\\}`,"g"),b[a]);return d}#triggerErrorPathNotFound(a){console.error("The path \""+a+"\" was not found in the current language ("+this.#options.lang+"), nor in the fallback language ("+this.#options.fallbackLang+").")}static#isUndefined(a){return"undefined"==typeof a}toJSON(){const{callback:a,translate:b,...c}=this.#options;return c}}